package GM;

sub link_handler
{
	my ($link)=@_;

	# Remove {{ and }}
	$link=~s/(\{|\})//g;
	$link=~s/^\s*link\s*//;
	my ($url,$text)=split(/\s/,$link,2);

	if((!defined($text)) || ($text =~ /^\s*$/))
	{
		$text=$url;
	}

	

	return "<a href=\"$url\" title=\"$text\">$text</a>";
}

sub img_handler
{
	my ($link)=@_;

	#
	# THIS DOESN'T WORK - instead, insert all the images from GM into
	# img_assist, and then work out the [...] tags required and let
	# drupal produce the right HTML for the image.
	#

	print "Handling image $link\n";

	$link=~s/(class=\"[^\"]*\")/class=\"image thumbnail\"/g;
	my $type=$1;

	print "Type is $type\n";

	if($type =~ /right/)
	{
		$link="<span class=\"inline right\">$link</span>";
	}
	elsif($type=~/left/)
	{
		$link="<span class=\"inline left\">$link</span>";
	}

	print "Returning $link\n";
	return "$link";
}

sub parse_text
{
	my ($text)=@_;

	$text=~s/(\{\{[^\}]*\}\})/&link_handler($1)/ge;

	$text=~s/\|\*\|/<br\/>\n/g;

	# Look for URLs not in an href and make them into links

	return $text;
}

sub check_text
{
	my ($text)=@_;

	$out='';

	if($text=~/(<img[^>]*>)/)
	{
		$out="# Has inline image";
		#print "Inline Image found: $1\n";
	}
	if($text=~/(<a(.*)href[^>]*>)/i)
	{
		my $link=$1;
		if($link=~/200(3|4)/)
		{
			if($out eq '')
			{
				$out="# Has href";
			}
			else
			{
				$out.=" and href";
			}
			#print "Inline Link found: $1\n";
		}
	}

	return $out;
}

1;
