#!/usr/bin/perl

use strict;
use DBI;
use Encode;

use Drupal;

sub run_sql
{
	my ($db,$sql)=@_;

	my $sth=$db->prepare($sql);
	my $rc=$sth->execute
		or die "Can't execute statement: $DBI::errstr";

	return $sth;
}

sub sqlify
{
	my ($sql)=@_;

	$sql=~s/\'/\\'/g;
	$sql=~s/\!/\\!/g;

	$sql=encode('iso-8859-1',$sql);

	return $sql;
}

sub convert
{
	my ($int)=@_;

	my @digits=(0..9,'a'..'z');

	my $out='';

	my $multi=$int % 35;
	if($multi > 0)
	{
		$out='1' . $digits[$int];
		$int=$int - ($multi * 36);
	}
	else
	{
		$out='0';
	}

	my $dig=$digits[$int];

	$out=$out.$dig . '/';

	return $out;
}

MAIN:
{

	my $drupal = DBI->connect('DBI:mysql:decaff2','coofer','catsrock');
	unless($drupal)
	{
		DBI::errstr;
		exit 1;
	}

	my $sth = $drupal->prepare("select * from comments");

	my $rc = $sth->execute
	      or die "Can't execute statement: $DBI::errstr";

	my @line;
	while (@line = $sth->fetchrow_array)
	{
		my $thread=$line[11];
		next if($thread=~/\./);
		next if($thread=~/^0/);
		my $num=$thread;
		$num=~s/\///;
		$num=$num+0;
		$thread=&convert($num);
		print "Thread: num=$num $thread (was $line[11])\n";

		my $cid=@line[0];

		my $update=$drupal->prepare("update comments set thread='$thread' where cid=$cid");

		my $out=$update->execute or die "Cannot execute update: $DBI::errstr";
	}

}
